summaryrefslogtreecommitdiffstats
path: root/tests/lib/ob_reduce_deps.sh
diff options
context:
space:
mode:
authorPatrick McDermott <patrick.mcdermott@libiquity.com>2019-03-17 01:23:28 (EDT)
committer Patrick McDermott <patrick.mcdermott@libiquity.com>2019-03-17 01:23:28 (EDT)
commite12e99c4fea06eaa13e4d08f4d9001b7f815fe2b (patch)
tree5500182852921d4ac808968b4476417257bd05f8 /tests/lib/ob_reduce_deps.sh
parentd23cbcd54fb5bc86ad6e00e6a5ae8384bdd8cc0a (diff)
tests/*.sh: Move to tests/lib/
Diffstat (limited to 'tests/lib/ob_reduce_deps.sh')
-rwxr-xr-xtests/lib/ob_reduce_deps.sh134
1 files changed, 134 insertions, 0 deletions
diff --git a/tests/lib/ob_reduce_deps.sh b/tests/lib/ob_reduce_deps.sh
new file mode 100755
index 0000000..b1e8609
--- /dev/null
+++ b/tests/lib/ob_reduce_deps.sh
@@ -0,0 +1,134 @@
+# Tests for ob_reduce_deps()
+#
+# Copyright (C) 2012, 2018 Patrick McDermott
+#
+# This file is part of opkbuild.
+#
+# opkbuild is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# opkbuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with opkbuild. If not, see <http://www.gnu.org/licenses/>.
+
+set -eu
+
+. "${TOP_SRCDIR}/tests/aux/tap-functions.sh"
+. "${TOP_BUILDDIR}/lib/libopkbuild.${SHSOEXT}.${LIBOPKBUILD_SHSOVERSION}"
+
+plan_ 11
+
+# Normal and union AND-lists.
+
+command_ok_ \
+ 'NORMAL LIST "foo, bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo, bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+command_ok_ \
+ 'NORMAL LIST "foo,bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo,bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+command_ok_ \
+ 'NORMAL LIST "foo, bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo, bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+command_ok_ \
+ 'UNION LIST "foo, bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -u \
+ -a 'amd64-linux-glibc' \
+ 'foo, bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+command_ok_ \
+ 'UNION LIST "foo,bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -u \
+ -a 'amd64-linux-glibc' \
+ 'foo,bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+command_ok_ \
+ 'UNION LIST "foo, bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -u \
+ -a 'amd64-linux-glibc' \
+ 'foo, bar' \
+ )" = \
+ x'foo, bar' \
+ ]
+
+# Normal OR-lists.
+
+command_ok_ \
+ 'NORMAL LIST "foo | bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo | bar' \
+ )" = \
+ x'foo | bar' \
+ ]
+
+command_ok_ \
+ 'NORMAL LIST "foo|bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo|bar' \
+ )" = \
+ x'foo | bar' \
+ ]
+
+command_ok_ \
+ 'NORMAL LIST "foo | bar"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo | bar' \
+ )" = \
+ x'foo | bar' \
+ ]
+
+# Normal and union AND-lists with arch specs.
+
+command_ok_ \
+ 'NORMAL LIST "foo [amd64-linux-glibc], bar [!amd64-linux-glibc]"' -- \
+ [ x"$(ob_reduce_deps \
+ -a 'amd64-linux-glibc' \
+ 'foo [amd64-linux-glibc], bar [!amd64-linux-glibc]' \
+ )" = \
+ x'foo' \
+ ]
+
+command_ok_ \
+ 'UNION LIST "foo [amd64-linux-glibc], bar [!amd64-linux-glibc]"' -- \
+ [ x"$(ob_reduce_deps \
+ -u \
+ -a 'amd64-linux-glibc' \
+ 'foo [amd64-linux-glibc], bar [!amd64-linux-glibc]' \
+ )" = \
+ x'foo' \
+ ]